#include <stdlib.h>
#include <ctype.h>
#include <string>
#include <windows.h>
#include <oleauto.h>
#include <objbase.h>
#include <atlbase.h>
#include <atlsafe.h>
#include <atlcomcli.h>
#include "GoogleDesktopAPI.h"

// Define conversation timeout interval by minutes
#define CONVERSATION_TIMEOUT 10

using namespace std;

BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved);
void IndexChannelConversationToOther(const char* SenderNick, const char* SenderUsername, const char* SenderAddress, const char* Command, const char* Target, const char* Trail, char* Output);
void IndexChannelConversationFromOther(const char* SenderNick, const char* SenderUsername, const char* SenderAddress, const char* Command, const char* Target, const char* Trail, char* Output);
void IndexPrivateTalkToOther(const char* SenderNick, const char* SenderUsername, const char* SenderAddress, const char* Command, const char* Target, const char* Trail, char* Output);
void IndexPrivateTalkFromOther(const char* SenderNick, const char* SenderUsername, const char* SenderAddress, const char* Command, const char* Target, const char* Trail, char* Output);
bool RegisterIndexingComponent();
bool UnregisterIndexingComponent();
bool SendIndexingEvent(const char* content, const char* buddy_name, const char* title, const char* user_name, const unsigned long conversation_id, const double message_time);
unsigned long GetConversationID(const string Identifier, const double VariantTime);
double GetVariantTime();
string mIRCColorsToHTML(string Message);
string LimeChatColorsToHTML(string Message);
string ColorCodePage(int ColorCode);
string ReverseColorCodePage(int ColorCode);
string ColorNameToCode(string ColorName);

// {BC8F4266-B231-4925-B92F-FDF729508114}
static const CLSID clsid = { 0xbc8f4266, 0xb231, 0x4925, { 0xb9, 0x2f, 0xfd, 0xf7, 0x29, 0x50, 0x81, 0x14 } };
